/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.EsquemaTramoDAO;
import com.rjconsultores.ventaboletos.entidad.EsquemaCorrida;
import com.rjconsultores.ventaboletos.entidad.EsquemaTramo;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Rafius
 */
@Repository("esquemaTramoDAO")
public class EsquemaTramoHibernateDAO extends GenericHibernateDAO<EsquemaTramo, Integer>
        implements EsquemaTramoDAO {

    @Autowired
    public EsquemaTramoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    public List<EsquemaTramo> obtenerPorEsquemaCorrida(EsquemaCorrida ec) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("esquemaCorrida", ec));
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        return c.list();
    }

    public List<EsquemaTramo> obtenerPorEsquemaCorridaOrderNumSec(EsquemaCorrida ec) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("esquemaCorrida", ec));
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.addOrder(Order.asc("numsecuencia"));

        return c.list();
    }

    public List<EsquemaTramo> obtenerAtivosDesativosPorEsquemaCorrida(EsquemaCorrida esquemaCorrida) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("esquemaCorrida", esquemaCorrida));
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.addOrder(Order.asc("numsecuencia"));

        return c.list();
    }
    
    public Boolean verificarDuplicidadeEsquemaTramo(EsquemaTramo esquemaTramo){
    	Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("esquemaCorrida", esquemaTramo.getEsquemaCorrida()));
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.add(Restrictions.eq("numsecuencia", esquemaTramo.getNumsecuencia()));
        c.addOrder(Order.asc("numsecuencia"));

        return !c.list().isEmpty();
    }
}
